<script lang="ts" setup>
import { nextTick, onMounted, ref, watchEffect } from 'vue'
import type { VForm } from 'vuetify/components'
import type { User } from '@/types/User'
import { useBranchStore } from '@/stores/branch'
import { useRoleStore } from '@/stores/role'
import { useUserStore } from '@/stores/user'
import { useAuthStore } from '@/stores/auth'

const userStore = useUserStore()
const roleStore = useRoleStore()
const branchStore = useBranchStore()
const authStore = useAuthStore()

const roles = ref<string[]>([])
const status = ref<string[]>([])
const genders = ref<string[]>([])
const branches = ref<string[]>([])

function fillArraysFromStores() {
  const rolesSet = new Set(roleStore.roles.map((role) => role.name))
  const statusSet = new Set(userStore.users.map((user) => user.status))
  const genderSet = new Set(userStore.users.map((user) => user.gender))
  const branchSet = new Set(branchStore.branches.map((branch) => branch.name))

  const validUsers = userStore.users.filter((user) => user.age !== undefined && user.age !== null)

  const minAge = validUsers.reduce((min, user) => Math.min(min, user.age), Infinity)
  const maxAge = validUsers.reduce((max, user) => Math.max(max, user.age), -Infinity)

  const minSalary = userStore.users.reduce((min, user) => Math.min(min, user.salary), Infinity)
  const maxSalary = userStore.users.reduce((max, user) => Math.max(max, user.salary), -Infinity)

  roles.value = ['all', ...Array.from(rolesSet)]
  status.value = ['all', ...Array.from(statusSet)]
  genders.value = ['all', ...Array.from(genderSet)]
  if (authStore.getCurrentUser()!.role.name === 'เจ้าของกิจการ') {
    branches.value = ['all', ...Array.from(branchSet)]
  } else if (authStore.getCurrentUser()!.role.name === 'ผู้จัดการร้าน') {
    branches.value = [authStore.getCurrentUser()!.branch.name]
  }

  userStore.minAgeFil = minAge
  userStore.maxAgeFil = maxAge
  userStore.minSalaryFil = minSalary
  userStore.maxSalaryFil = maxSalary
}

onMounted(async () => {
  await userStore.getUsers()
  await roleStore.getRoles()
  await branchStore.getBranches()
  fillArraysFromStores()
})
</script>

<template>
  <v-card>
    <v-card-title class="text-h5">การค้นหา</v-card-title>
    <v-card-text>
      <v-row padding="px-4" style="margin-top: 10px; margin-bottom: 20px">
        <v-col cols="12" md="6">
          <v-combobox
            v-model="userStore.branchFil"
            label="สาขา"
            variant="outlined"
            :items="branches"
          ></v-combobox>
        </v-col>
        <v-col cols="12" md="6">
          <v-combobox
            v-model="userStore.roleFil"
            label="ตำแหน่ง"
            variant="outlined"
            :items="roles"
          ></v-combobox>
        </v-col>
        <v-col cols="12" md="6">
          <v-combobox
            v-model="userStore.genderFil"
            label="เพศ"
            variant="outlined"
            :items="genders"
          ></v-combobox>
        </v-col>
        <v-col cols="12" md="6">
          <v-combobox
            v-model="userStore.statusFil"
            label="สถานะการทำงาน"
            variant="outlined"
            :items="status"
          ></v-combobox>
        </v-col>
        <v-col cols="12" md="6">
          <v-text-field
            v-model="userStore.minAgeFil"
            label="อายุ (ตั้งแต่)"
            variant="underlined"
            type="number"
          ></v-text-field>
        </v-col>
        <v-col cols="12" md="6">
          <v-text-field
            v-model="userStore.maxAgeFil"
            label="อายุ (ถึง)"
            variant="underlined"
            type="number"
          ></v-text-field>
        </v-col>
        <v-col cols="12" md="6">
          <v-text-field
            v-model="userStore.minSalaryFil"
            label="เงินเดือน (ตั้งแต่)"
            variant="underlined"
            type="number"
          ></v-text-field>
        </v-col>
        <v-col cols="12" md="6">
          <v-text-field
            v-model="userStore.maxSalaryFil"
            label="เงินเดือน (ถึง)"
            variant="underlined"
            type="number"
          ></v-text-field>
        </v-col>
      </v-row>
    </v-card-text>
    <v-card-actions>
      <v-spacer></v-spacer>
      <v-btn color="blue-darken-1" variant="text" @click="userStore.getByFilter()">save</v-btn>
      <v-spacer></v-spacer>
    </v-card-actions>
  </v-card>
</template>
